function [vInnovations, vVarInnovations, mStatePred, mCovStatePred,...
    dLogLik, dSigma, dLogLikConc, dPev] = KalmanFilter(vy, mZ, mGG, mT, mHH, mHG, va, mP)
%----------------------------------------------------------------------
cm = length(va); % n. of state elements and of diffuse elements
ck = 1;   
cn = length(vy);
%----------------------------------------------------------------------
% Initialisation of matrices and scalars
dLogf = 0; dSumSquares = 0;     
vInnovations = NaN(1, cn);  % stores the KF innovations
vVarInnovations = NaN(1, cn); 
mStatePred = NaN(cm, cn); % stores the states predictions
mCovStatePred = NaN(cm, cn);
for i = 1:cn
	dv = vy(i) - mZ * va;      		dF = mZ * mP * mZ' + mGG;
    
                                    vK = (mT * mP * mZ' + mHG) / dF;
	va = mT * va + vK * dv; 		mP = mT * mP * mT' + mHH - vK * vK' * dF ;
    if (i > ck)
        vInnovations(i) = dv;       vVarInnovations(i) = dF;
        dLogf = dLogf + log(dF);    dSumSquares = dSumSquares + dv^2 /dF;
    end
    mStatePred(:,i) = va;       	mCovStatePred(:,i) = diag(mP);
end
dSigma = dSumSquares/(cn-ck);
dLogLik = -0.5 * ((cn - ck) * log(2 * pi) + dLogf + dSumSquares );
dLogLikConc = -0.5*((cn - ck)* (log(2 * pi * dSigma)+1) + dLogf ); 
dPev =  dSigma *  dF ;    % Final prediction error variance    
end
 