function vtheta = ReparMA( vr )
%Monahan's reparameterisation enforcing invertibility (1984 Bmtk)
%    Maps r_j in (-1,1) to MA $\theta_j$ within the stationary region
cq = length(vr); % order of AR
vtheta = zeros(cq,1);
vtheta(1) = vr(1);
for k = 2:cq	
    vtheta(1:k-1) = vtheta(1:k-1) + vr(k) * vtheta(k-1:-1:1);
    vtheta(k) = vr(k);
end 
end

