function [mZ, mGG, mT, mHH, mHG, va, mP] = SetStateSpaceModel(vP, cp, cq)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ARMA MODEL
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
cm = max(cp,cq);     % number of state elements
vphi   = zeros(cm, 1);
vtheta = zeros(cm, 1); 
if (cp > 0) 
    vphi(1:cp) = ReparAR(FisherInvTransform(vP(1:cp)));
end
if (cq > 0) 
    vtheta(1:cq) = ReparMA(FisherInvTransform(vP(cp+1:cp+cq)));
end
% Measurement equation: % y_{t} = Z_t \alpha_{t} +  G_t \epsilon_t
mZ = [1, zeros(1, cm-1)];     mGG = 1; % G_t * G_t'
% Transition equation:  % \alpha_{t+1} = T_t \alpha_{t} + H_t \epsilon_t
mT = [vphi,  [eye(cm-1); zeros(1, cm-1)] ];     
disp(mT); disp( vphi);
mH = vtheta+vphi;
mHH = mH*mH'; % H_t * H_t'  
mHG = mH;
%%%%%%%%%%%%%%% Initial conditions               %%%%%%%%%%%%%%%%%%%%%%%%%
va = zeros(cm,1);     
mP = reshape(inv(eye(cm^2)-kron(mT,mT)) * reshape(mHH, cm^2,1) , cm, cm);    %        
end


