function [mAs, mPs] = KFStateSmoother(vy, mZ, mGG, mT, mHH, va, mP)
%----------------------------------------------------------------------
cn = length(vy); 
cm = length(va);
%----------------------------------------------------------------------
% Initialisation of arrays of matrices and scalars
av = repmat(NaN, [1 1 cn]); 
aF = repmat(NaN, [1 1 cn]);
aK = repmat(NaN, [cm 1 cn]);
aaf = repmat(NaN, [cm 1 cn]);
aP = repmat(NaN, [cm cm cn]);
for i = 1:cn
	aaf(:,:,i) = va; 	aP(:,:,i) = mP;	 % store a_{t|t-1}, P_{t|t-1}
	dv = vy(i) - mZ * va;       dF= mZ * mP * mZ' + mGG;
                            	vK = mT * mP * mZ' / dF;
    av(:,:,i) = dv;             aF(:,:,i) = dF;
	aK(:,:,i) = vK;
	va = mT * va + vK * dv; 	mP = mT * mP * mT' + mHH - vK * dF * vK'  ;
end

vr = zeros(cm,1);  mN = zeros(cm,cm);
mAs = NaN(cm, cn); 	mPs = NaN(cm, cn); 
for i = cn:-1.0:1
	disp(['Smoothing observation: ', num2str(i)]);
 	dFinv =  1 / aF(:,:,i);
	mL = mT - aK(:,:,i) * mZ;			
	vr = mZ' * dFinv * av(:,:,i) + mL' * vr;	
	mN = mZ' * dFinv * mZ + mL' * mN * mL;
	va = aaf(:,:,i); mP = aP(:,:,i);
    mAs(:,i) =  va + mP * vr;
	mPs(:,i) = diag(mP - mP * mN * mP);
        
end
end