% MLE of the signal to noise ratio
clear all; clc;
cpi = xlsread('uscpi.xls');
% US monthly inflation rate
vy = 100 * diff(log( cpi( (1960-1947)*12:end) ) );
startdate = 1960;	% date range is from 1947:1 to 2011:2 (quarterly)
enddate = 2013;	% change these two lines to try alternative periods
 
dates =  startdate:0.0833:enddate;
dates = dates(1:length(vy));

plot(dates, vy);
plot(vy);
% ------------------------------------------------------------------------
% initial value transformed hyperparameter: theta = ln sqrt q
theta0 = 0;  
f  = @(theta)SsfLogLikConc(theta, vy); % function 
opts = optimset('Display','iter','TolX',1e-9,'TolFun',1e-9,...
                'Diagnostics','off', 'MaxIter',10000, 'MaxFunEvals', 10000,...
                'LargeScale', 'off', 'PlotFcns', @optimplotfval);
[theta, fval, exitflag, output] = fminunc(f, theta0,opts);
theta
q = exp(2 * theta); 
disp(['MLE of signal noise ratio is ', num2str(q)]);
  
