% Plots the concentrated (profile) minus log likelihood as a function of the 
% signal to noise ratio and its transformation 0.5 ln q.
clear all; clc;
cpi = xlsread('uscpi.xls');
% US monthly inflation rate
vy = 100 * diff(log( cpi( (1960-1947)*12:end) ) );
plot(vy);
% ------------------------------------------------------------------------
% values of 0.5 log signal to noise ratio (\ln \sqrt{q})
vlogq = -3:.01:1;
nq = length(vlogq);

vLogLikConc = NaN(nq,1);
for (k = 1:nq)
    dlogq = vlogq(k);
    [mZ, mGG, mT, mHH, va, mP] = SetStateSpaceModel(dlogq);
    vLogLikConc(k) = SsfLogLikConc(dlogq, vy);
end
subplot(1,2,1), plot(vlogq, vLogLikConc), title('Profile Lik 0.5 ln q') ;
vq = exp(2 * vlogq);
subplot(1,2,2), plot(vq(1:250), vLogLikConc(1:250)), title('Profile Lik q') ;;   
